/*
 * DAS GEHEIMNIS DER IRREN BUSFAHRER
 * ---------------------------------
 */

import  java.awt.*;
import  java.applet.*;

public class BusplanGeruest
  extends Applet
  implements Runnable /* das msst Ihr nicht verstehen */
{

  /* Die Grsse des Applet-Fensters. */
  final int FENSTERMAX_I = 800;
  final int FENSTERMAX_J = 800;

  /* Das sind die Eckpunkte unseres Stadtplans. */
  final double XMIN = -2.2, XMAX = 2.2, YMIN = -2.2, YMAX = 2.2;


  /* hauptProgramm ************************************************************
     **************************************************************************
   */

  public void hauptProgramm(Graphics bildschirm) {
  }


  /* *********************** Eigene Methoden ******************* */




  /* ******** Methoden fr die Bildschirmdarstellung ************ */

  /* zeichneFahrstrecke ********************************************
     Die Busstrecke wird im Stadtplan eingezeichnet. Die Position der aktuellen
     und der letzten Haltestelle bekommt man als Parameter. Die Koordinaten
     der Haltestellen werden nun in Bildschirmkoordinaten umgerechnet.  */

  void zeichneFahrstrecke (double x, double y, double xnew, double ynew, Graphics bildschirm) {
	/* Schritt 5 */
  }


  /* zeichneStadtgrenze ***********************************************
     Diese Methode berechnet die Koordinaten fr die Stadtgrenze
     und zeichnet sie. Die Position und Grsse des Kreises werden definiert,
     indem ein Quadrat um den Kreis herum festgelegt wird. Dazu werden
     der obere linke Eckpunkt, die Breite und Hhe angegeben. */

  void zeichneStadtgrenze (Graphics bildschirm) {
    int linksObenI, linksObenJ;
    int rechtsUntenI, rechtsUntenJ;
    int breite, hoehe;

    linksObenI   = (int)berechneBildschirmI (-2.0);
    linksObenJ   = (int)berechneBildschirmJ (2.0);
    rechtsUntenI = (int)berechneBildschirmI (2.0);
    rechtsUntenJ = (int)berechneBildschirmJ (-2.0);
    breite       = rechtsUntenI - linksObenI;
    hoehe        = rechtsUntenJ - linksObenJ;

    /* Der Kreis wird im Graphikfenster gezeichnet. */
    bildschirm.drawOval (linksObenI, linksObenJ, breite, hoehe);
  } /* Ende von zeichneStadtgrenze */



  /* berechneBildschirmI / berechneBildschirmJ *****************************************************
     Die Koordinaten des Stadtplans (von XMIN bis XMAX und
     von YMIN bis YMAX) mssen in Bildschirmkoordinaten (I,J) umgerechnet werden.
     Zuerst werden die Koordinaten vom linken Stadtplanrand gemessen (statt
     vom Nullpunkt aus: x-XMIN). Die Division durch die Stadtplanbreite
     (XMAX-XMIN) ergibt den "prozentualen" Abstand vom linken Stadtplanrand.
     Dieser Wert wird mit der Fensterbreite multipliziert, um den Abstand
     vom linken Fensterrand zu berechnen.

     Die Umrechnung in J-Richtung ist analog.
     Achtung: Bei den Bildschirmkoordinaten in j-Richtung ist der Nullpunkt
     oben! Zunehmende j-Werte wachsen nach unten, also gerade umgekehrt als
     wie man es sich gewohnt ist.*/

  int berechneBildschirmI (double x) {
    double bildschirmI;
    bildschirmI = ((x-XMIN) / (XMAX-XMIN)) * FENSTERMAX_I ;
     /* Es knnen nur Punkte (und Linien) mit Integer-Koordinaten gezeichnet weden.
       Alle double Zahlen werden deshalb auf Integer abgebildet. */
    return (int) bildschirmI;
  } /* Ende von berechneBildschirmI */

  int berechneBildschirmJ (double y) {
    double bildschirmJ;
    bildschirmJ = FENSTERMAX_J - (((y-YMIN) / (YMAX-YMIN)) * FENSTERMAX_J );
     /* Es knnen nur Punkte (und Linien) mit Integer-Koordinaten gezeichnet weden.
       Alle double Zahlen werden deshalb auf Integer abgebildet. */
    return (int) bildschirmJ;
  }  /* Ende von berechneBildschirmJ */


  /* berechneStadtplanX / berechneStadtplanY *****************************************************
     Die Koordinaten des Bildschirmes (X,Y) mssen in Stadtplan-Koordinaten (I,J)
     umgerechnet werden.
     Wenn wir die Zahl i durch die Konstante FENSTERMAX_I teilen, haben wir den
     "prozentualen" Anteil. Multipliziert mit (XMAX-XMIN) ergibt das den Abstand
     vom linken Stadtrand. Wenn wir also XMIN addieren, haben wir die Stadtplan-
     koordinate.

     Die Umrechnung in Y-Richtung ist analog.
     Achtung: Bei den Bildschirmkoordinaten in j-Richtung ist der Nullpunkt
     oben! Zunehmende j-Werte wachsen nach unten, also gerade umgekehrt als
     wie man es sich gewohnt ist.*/

  double berechneStadtplanX (int i) {
    double stadtplanX;
     /* Da die Stadtplanwerte nicht nur ganze Zahlen sind, muss dafr gesorgt
        werden, dass Java mit double Zahlen rechnet.*/
    stadtplanX = ( ((double)i / FENSTERMAX_I) * (XMAX-XMIN) ) + XMIN;
    return stadtplanX;
  } /* Ende von berechneBildschirmI */

  double berechneStadtplanY (int j) {
    double stadtplanY;
     /* Da die Stadtplanwerte nicht nur ganze Zahlen sind, muss dafr gesorgt
        werden, dass Java mit double Zahlen rechnet.*/
    stadtplanY = ( ((double)(FENSTERMAX_J-j) / FENSTERMAX_J) * (YMAX-YMIN) ) + YMIN;
    return stadtplanY;
  } /* Ende von berechneBildschirmI */


  /* *******************************************************
   * Hier beginnt der kryptische Teil vom Java-Programm. Den Teil brauchst du nicht
   * zu verstehen. Sogar Profis haben Mhe, immer genau den berblick zu behalten.
   */

  public Graphics zeichnungsBrett;
  public Image zeichnungsBrettBild;
  private Thread thread;
  private boolean isRunning = false;

  public void init() {
    /* Wird zu Beginn (vom Appletviewer) aufgerufen, wenn das Applet gestartet wird.
     */
    thread = null;
    zeichnungsBrettBild = createImage(FENSTERMAX_I, FENSTERMAX_J);
    zeichnungsBrett = zeichnungsBrettBild.getGraphics();
  }

  public void start() {
    /* Kreiert einen neuen Thread, der nur fr unser hauptProgramm zustndig ist.
     * Der "alte" Thread bleibt auch aktiv, er sorgt dafr, dass das Gezeichnete
     * wenn ntig neu dargestllt wird.
     */
    if (thread == null) {
      thread = new Thread(this);
    }
    thread.start();
  }

  public void run() {
    /* Diese Methode wird durch thread.start(); ausgelst. Sie ruft unsere
     * Methode hauptProgramm() auf und beendet den Thread anschliessend.
     */
    isRunning = true;
    hauptProgramm(zeichnungsBrett);
    isRunning = false;
  }

  public void stop() {
    /* Wenn der Appletviewer beendet wird, so soll auch der Thread, der fr das
     * Neuzeichnen zustndig ist, beendet werden.
     */
    if ( (thread != null) && thread.isAlive() ) {
      thread.interrupt();
      thread = null;
      isRunning = false;
    }
  }

  public void zeichneZeichnungsBrettAufDenBildschirm(Graphics bildschirm) {
    bildschirm.drawImage(zeichnungsBrettBild, 0, 0, null);
  }

  public void update(Graphics bildschirm) {
    /* Wird vom der Methode repaint aufgerufen.
     * Wird keine update Methode deklariert, so wird der Bildschirm weiss gezeichnet
     * und anschliessend die Methode paint aufgerufen
     */
    zeichneZeichnungsBrettAufDenBildschirm(bildschirm);
  }

  public void paint(Graphics bildschirm) {
    /* zeichnet den Bildschirm neu, wenn ein anderes Fenster vorher einen Teil
     * verdeckt hat und nun dieses Fenster sich verndert hat.
     */
    zeichneZeichnungsBrettAufDenBildschirm(bildschirm);
  }

  public void schlafe(int schlafZeit) {
    /* legt das Programm eine gewisse Zeit schlafen. Die Zahl schlafZeit gibt die
     * Dauer des Schlafens in Millisekunden an. */
    try {
      if (isRunning) {
        repaint();
        Thread.sleep(schlafZeit);
      }
    }
    catch (InterruptedException e) {
      // Exception abfangen
    }
  }

}  /* Ende von Busplan */
